'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _electron = require('electron');

var _trimStart = require('lodash/trimStart');

var _trimStart2 = _interopRequireDefault(_trimStart);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// https://github.com/electron/electron/blob/master/docs/api/menu/
exports.default = function (options) {
    // routes = [
    //   {
    //     path: '/widget',
    //     directory: '~+/widget'
    //   }
    // ]
    var _options = (0, _extends3.default)({}, options),
        address = _options.address,
        port = _options.port,
        _options$routes = _options.routes,
        routes = _options$routes === undefined ? [] : _options$routes;

    var menuItems = routes.map(function (route) {
        return {
            label: route.path + ': ' + route.directory,
            click: function click() {
                var path = (0, _trimStart2.default)(route.path, '/');
                var url = 'http://' + address + ':' + port + '/' + path;
                _electron.shell.openExternal(url);
            }
        };
    });

    var template = [{
        label: _electron.app.getName(),
        submenu: [{ role: 'about' }, { type: 'separator' }, { role: 'services', submenu: [] }, { type: 'separator' }, { role: 'hide' }, { role: 'hideothers' }, { role: 'unhide' }, { type: 'separator' }, { role: 'quit' }]
    }, {
        label: 'Edit',
        submenu: [{ role: 'undo' }, { role: 'redo' }, { type: 'separator' }, { role: 'cut' }, { role: 'copy' }, { role: 'paste' }, { role: 'pasteandmatchstyle' }, { role: 'delete' }, { role: 'selectall' }, { type: 'separator' }, {
            label: 'Speech',
            submenu: [{ role: 'startspeaking' }, { role: 'stopspeaking' }]
        }]
    }, {
        label: 'View',
        submenu: [{ role: 'reload' }, { role: 'forcereload' }, { role: 'toggledevtools' }, { type: 'separator' }, { role: 'resetzoom' }, { role: 'zoomin' }, { role: 'zoomout' }, { type: 'separator' }, { role: 'togglefullscreen' }, { type: 'separator' }, {
            label: 'Home',
            click: function click() {
                var url = 'http://' + address + ':' + port;
                _electron.shell.openExternal(url);
            }
        }].concat(menuItems)
    }, {
        role: 'window',
        submenu: [{ role: 'close' }, { role: 'minimize' }, { role: 'zoom' }, { type: 'separator' }, { role: 'front' }]
    }, {
        role: 'help',
        submenu: [{
            label: 'Learn More',
            click: function click() {
                _electron.shell.openExternal('https://snapmaker.com/support/');
            }
        }]
    }];

    return template;
};