'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

require('babel-polyfill');

var _electron = require('electron');

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _WindowManager = require('./electron-app/WindowManager');

var _WindowManager2 = _interopRequireDefault(_WindowManager);

var _menuTemplate = require('./electron-app/menu-template');

var _menuTemplate2 = _interopRequireDefault(_menuTemplate);

var _cnc = require('./cnc');

var _cnc2 = _interopRequireDefault(_cnc);

var _package = require('./package.json');

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// The selection menu
var selectionMenu = _electron.Menu.buildFromTemplate([{ role: 'copy' }]);

// The input menu
/* eslint import/no-unresolved: 0 */
var inputMenu = _electron.Menu.buildFromTemplate([{ role: 'copy' }, { role: 'paste' }]);

var windowManager = null;

var main = function main() {
    // https://github.com/electron/electron/blob/master/docs/api/app.md#appmakesingleinstancecallback
    var shouldQuit = _electron.app.makeSingleInstance(function (commandLine, workingDirectory) {
        // Someone tried to run a second instance, we should focus our window.
        if (!windowManager) {
            return;
        }

        var window = windowManager.getWindow();
        if (window) {
            if (window.isMinimized()) {
                window.restore();
            }
            window.focus();
        }
    });

    if (shouldQuit) {
        _electron.app.quit();
        return;
    }

    // Create the user data directory if it does not exist
    var userData = _electron.app.getPath('userData');
    _mkdirp2.default.sync(userData);

    _electron.app.commandLine.appendSwitch('ignore-gpu-blacklist');
    _electron.app.on('ready', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var data, _data, address, port, routes, menu, url, window;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return (0, _cnc2.default)();

                    case 3:
                        data = _context.sent;
                        _data = (0, _extends3.default)({}, data), address = _data.address, port = _data.port, routes = _data.routes;

                        // Menu

                        menu = _electron.Menu.buildFromTemplate((0, _menuTemplate2.default)({ address: address, port: port, routes: routes }));

                        _electron.Menu.setApplicationMenu(menu);

                        // Window
                        url = 'http://' + address + ':' + port;


                        windowManager = new _WindowManager2.default();
                        window = windowManager.openWindow(url, {
                            width: 1280,
                            height: 768,
                            title: _package2.default.name + ' ' + _package2.default.version
                        });

                        // https://github.com/electron/electron/issues/4068#issuecomment-274159726

                        window.webContents.on('context-menu', function (event, props) {
                            var selectionText = props.selectionText,
                                isEditable = props.isEditable;


                            if (isEditable) {
                                // Shows an input menu if editable
                                inputMenu.popup(window);
                            } else if (selectionText && String(selectionText).trim() !== '') {
                                selectionMenu.popup(window);
                            }
                        });
                        _context.next = 16;
                        break;

                    case 13:
                        _context.prev = 13;
                        _context.t0 = _context['catch'](0);

                        console.error('Error: ', _context.t0);

                    case 16:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined, [[0, 13]]);
    })));
};

main();